#include <Wire.h>

int i;

void setup() {
  delay(2000);
  Wire.begin();
  // speed of 12.5kHz for Arduino UNO, see www.gammon.com.au/i2c
  TWBR = 158;
  TWSR |= bit (TWPS0);
  Serial.begin(115200);
  delay(1000);
  for (i = 1; i <= 12; i++) {
    i2c_transfer(0b000000000000100110000001); // 0x00, 0x09, 0x81
    i2c_transfer(0b000100000001111101100101); // 0x10, 0x1f, 0x65
    i2c_transfer(0b001000000000000000000000); // 0x20, 0x00, 0x00
    delay(3);
  }
}

void i2c_transfer(uint32_t value) {
  byte buf[3];
  buf[0] = (value >> 16) & 0xFF;
  buf[1] = (value >> 8) & 0xFF;
  buf[2] = value & 0xFF;
  bool success = 0;
  while (!success) {
    Serial.print(i);
    Serial.print(" ");
    Serial.print("sending: ");
    Serial.print(buf[0], HEX);
    Serial.print(" ");
    Serial.print(buf[1], HEX);
    Serial.print(" ");
    Serial.print(buf[2], HEX);
    Serial.print(" ");
    Wire.beginTransmission(0b0000000); // 7bit slave address
    Wire.write(buf, sizeof buf);
    if (Wire.endTransmission()) {
      Serial.println("error!");
    } else {
      Serial.println("success!");
      success = 1;
    }
    delay(1);
  }
}

void loop() {}
